#include <p18F2550.h>
#include <usart.h>
#include <stdlib.h> 
#include <delays.h>
#include <float.h>
#include <adc.h>
#include <string.h>
#include <i2c.h>
#include <math.h>
#include "1wire.h"

//#include "system\typedefs.h"
//#include "system\usb\usb.h"
//#include "io_cfg.h"             // I/O pin mapping

#define	ENL LATCbits.LATC6
#define	RSL LATCbits.LATC7
#define Cycles 500
#define Cycles_j 6


static unsigned char Ypos;
unsigned int n;
unsigned char hadd;                    //High Order Address Byte
unsigned char ladd;                     //Low Order Address Byte
unsigned char data;                       //data Byte
unsigned char length;                     //length of bytes to read
unsigned int  pagesize,MemAd;                   //Page size in bytes
//unsigned char pstring[64];             // Holds the device page data 
unsigned char Icounter,Kcounter,Jcounter,Lcounter;
unsigned char str01[16],DisplayBuffer[17];
unsigned char mode;
char tem;
long  result;
float 		pressure,altitude,alt,altold1,altold2,altold3,temper;
//void lowspeed_init(void);
void InterruptHandlerHigh (void);

#define button_pl PORTBbits.RB5
#define button_mi PORTBbits.RB4
#define button_ok PORTCbits.RC1

typedef unsigned char   byte;           // 8-bit
typedef union _BYTE
{
    byte _byte;
    struct
    {
        unsigned b0:1;
        unsigned b1:1;
        unsigned b2:1;
        unsigned b3:1;
        unsigned b4:1;
        unsigned b5:1;
        unsigned b6:1;
        unsigned b7:1;
    };
} BYTE;

BYTE	flag;

#define		FlagOk flag.b0
#define		FlagPl flag.b1
#define		FlagMi flag.b2
#define		FlagOff flag.b3
#define		FlagMem flag.b4

void lcdt (unsigned char data);
void lcdc (unsigned char data);
void initLCD(void);




void initLCD(void)
{
	Delay1KTCYx(50); // Delay of 15ms		
	RSL=0;
	LATB=LATB|0x0C;
	LATB=LATB&0x0F;
	ENL=1;
	_asm
	nop
	_endasm
	ENL=0;
	Delay1KTCYx(4); // Delay of 15ms		
	ENL=1;
	_asm
	nop
	_endasm
	ENL=0;
	Delay1KTCYx(1); // Delay of 15ms		
	ENL=1;
	_asm
	nop
	_endasm
	ENL=0;
	Delay1KTCYx(1); // Delay of 15ms		
	LATB=LATB&0x03;
	LATB=LATB|0x08;
	ENL=1;
	_asm
	nop
	_endasm
	ENL=0;
	Delay1KTCYx(4); // Delay of 15ms		
	Ulcdc(0x28);		//!!!2lines!!!, 4bit,5*7font
	Ulcdc(0x0C);		//disp on,blink & cursor off
	Ulcdc(0x01);		//erase disp, cursor home
}


void lcdc (unsigned char data)
{
	unsigned char datat;
	datat=data;
	RSL=0;
	ENL=1;
	datat>>=4;
	datat=datat&0x0F;
	datat<<=2;
	LATB=LATB&0x03;
	LATB=(LATB|datat);
	ENL=0;
	RSL=0;
	ENL=1;
	data<<=2;
	LATB=LATB&0x03;
	LATB=(LATB|(data&0x3F));
	ENL=0;
	Delay10TCYx(20);
}


void lcdt (unsigned char data)
{
	unsigned char datat;
	datat=data;
	RSL=1;
	ENL=1;
	datat>>=4;
	datat=datat&0x0F;
	datat<<=2;
	LATB=LATB&0x03;
	LATB=(LATB|datat);
	ENL=0;
	RSL=1;
	ENL=1;
	data<<=2;
	LATB=LATB&0x03;
	LATB=(LATB|(data&0x3F));
	ENL=0;
	Delay10TCYx(20);
}

void putslcd(char *data)
{
	if ((Ypos<0)|(Ypos>15)) Ypos=0;
	if (Ypos==0) lcdc(0b10000000);
	if ((Ypos>=0)&(Ypos<=7))
		{
		while((*data != '\0')&(Ypos<8))
  			{  
		  	lcdt(*data);
			*data++;
			Ypos++;
		  	}
		}
if (Ypos==8) lcdc(0b11000000);
if ((Ypos>=8)&(Ypos<=15))
		{
		while((*data != '\0')&(Ypos<16))
  			{  
		  	lcdt(*data);
			*data++;
			Ypos++;
		  	}
		}
}


void putrslcd(const rom char *data)
{
//	if (y<20) Ypos=y;
	if ((Ypos<0)|(Ypos>15)) Ypos=0;
	if (Ypos==0) lcdc(0b10000000);
	if ((Ypos>=0)&(Ypos<=7))
		{
		while((*data != '\0')&(Ypos<8))
  			{  
		  	lcdt(*data);
			*data++;
			Ypos++;
		  	}
		}
if (Ypos==8) lcdc(0b11000000);
if ((Ypos>=8)&(Ypos<=15))
		{
		while((*data != '\0')&(Ypos<16))
  			{  
		  	lcdt(*data);
			*data++;
			Ypos++;
		  	}
		}
}

void write_nil(void)
{
unsigned char i;
if (Ypos<15)
	{
	for (i=Ypos;i<16;i++) 
		{
		if ((i<0)|(i>15)) i=0;
		if (i==0) lcdc(0b10000000);
		if ((i>=0)&(i<=7))
			{
			while(i<8)
	  			{  
			  	lcdt(' ');
				i++;
			  	}
			}
		if (i==8) lcdc(0b11000000);
		if ((i>=8)&(i<=15))
			{
			while(i<16)
	  			{  
			  	lcdt(' ');
				i++;
		  		}
			}
		}
	}
}

void On(void)
{
	FlagOff=0;
	DDRB=0;
	TRISCbits.TRISC2=1;
  	DDRCbits.RC1 = 1;
	PORTC=0b00000100;
  	DDRCbits.RC7 = 0;
  	DDRCbits.RC6 = 0;
  	DDRCbits.RC0 = 0;
	LATCbits.LATC0=0;
	Delay10KTCYx(10);
	initLCD();
	lcdt('A');
	PORTAbits.RA3=1;
	Delay10KTCYx(25);
	LATCbits.LATC0=1;
	Delay10KTCYx(30);
	lcdt('B');
}

void lowspeed_init(void)
{
	TRISAbits.TRISA0=1;
	TRISAbits.TRISA1=1;
	TRISAbits.TRISA2=0;
	TRISAbits.TRISA3=1;
	DDRBbits.RB2 = 0;       //Define CS as Output
	DDRBbits.RB1 = 0;       //Define SCK as Output
  	DDRBbits.RB0 = 1;
	DDRBbits.RB7 = 1;
  	DDRBbits.RB6 = 1;
	SSPSTAT = 0xC0;         //SPI Bus mode 0,0
	SSPCON1 = 0x21;         //Enable SSP, Fosc/16

}


void main_lowspeed (void)
{
	unsigned int res,i,j;
	FlagOff=0;
	FlagMem=0;
	MemAd=100;
	mode=0;
	Kcounter=0;
	Icounter=0;
	Jcounter=0;
	Lcounter=0;
	hadd = 0x02;                         //hadd is first byte transmitted for High Density devices
  	ladd = 0x10;                          //ladd is only Address byte for Low Density, second byte to HD
  	data = 'Z';                            //data can be whatever user would like
  	length = 0x01;                          //length param set to 1 for single byte read
  	pagesize = 16;                        //pagesize is Physical page boundry from datasheet. (0x10 = 16, 0x20 = 32)
	TRISAbits.TRISA0=1;
	INTCON2bits.RBPU=0;
	ADCON0=0x01;
	ADCON1=0x1D;
	ADCON2=0x3C;
	ADCON2bits.ADFM=1;
	OpenI2C(MASTER, SLEW_ON);// Initialize I2C module
	SSPADD = 0x09;
	PORTAbits.RA2=1;
/*	EByteWrite(0xA0,0x00,0x03,0x33);
	EEAckPolling(0xA0);

	res = EByteRead(0xA0,0x00,0x03);

	EByteWrite(0xA0,0x00,0x04,0xF3);
	EEAckPolling(0xA0);

	res = EByteRead(0xA0,0x00,0x04);

	ESeqRead(0xA0, 0x00, 0x00, str01, 6);
	EEAckPolling(0xA0);*/
//	cal();
	TMR1L=188;	
	TMR1H=60;
	PIE1bits.TMR1IE=1;
	T1CON=0b00000001;
//	RCONbits.IPEN=0;
//	IPR1bits.TMR1IP=1;
  	INTCONbits.GIE = 1; 
  	INTCONbits.PEIE = 1; 
	lcdt('C');
	FlagOff=0;
while (1)
		{
		alt=0;
		for (j=0;j<Cycles_j;j++)
				{
				result=0;
				for (i=0;i<Cycles;i++)
					{
					ConvertADC(); // Start conversion
					while( BusyADC() ); // Wait for completion
					result = result + ReadADC(); // Read result		
					}
				pressure = (((result / (1023.0*Cycles))+0.095)* 1111.1111);
				alt=alt + (-log(pressure/1018.0))*((286.0*(temper+273.15))/9.81);
				}

		alt=alt/Cycles_j;
		altitude=(alt+altold1+altold2+altold3)/4.0;
		altold3=altold2;
		altold2=altold1;
		altold1=alt;
		lcdt('D');
		Delay10KTCYx(40);	
	  	INTCONbits.GIE = 0; 
	  	INTCONbits.GIE = 0; 
		temper = Read_Temperature_DS18S20();
		Convert_Temperature();						// initiate a convert
	  	INTCONbits.GIE = 1; 
	  	INTCONbits.GIE = 1;
/*		putslcd(DisplayBuffer);
		write_nil();
		Delay10KTCYx(10);*/

		if (FlagOff==1)
			{

		  	INTCONbits.GIE = 0; 
			strcpypgm2ram(DisplayBuffer,"..OFF...");			
			putslcd(DisplayBuffer);
			Delay10KTCYx(250);
			Delay10KTCYx(250);
			Ypos=0;
			write_nil();
			Delay10KTCYx(10);
			PORTCbits.RC0=0;
			}


		}//looping forever

}

#pragma code InterruptVectorHigh = 0x08
void
InterruptVectorHigh (void)
{
  _asm
    goto InterruptHandlerHigh //jump to interrupt routine
  _endasm
}

//----------------------------------------------------------------------------
// High priority interrupt routine

#pragma code
#pragma interrupt InterruptHandlerHigh

void InterruptHandlerHigh ()
{
//	unsigned char save_trisb;
	if (PIR1bits.TMR1IF) //no. 1
		{
		lcdt('G');
		PIR1bits.TMR1IF=0;
		PORTAbits.RA3=~PORTAbits.RA3;
		TMR1L=188;	
		TMR1H=60;
		Icounter++;
		Kcounter++;
		TRISB=0xFF;
		if (button_pl==0)
				{
				if (button_pl==0) FlagPl=1;
				}
		else FlagPl=0;

		if (button_mi==0)
				{
				if (button_mi==0) FlagMi=1;
				}
		else FlagMi=0;

		if (button_ok==0)
				{
				if (button_ok==0) FlagOk=1;
				}
		else FlagOk=0;

		TRISB=TRISB&0b11000011;

		if (Kcounter==42)
			{
			Kcounter=40;
			if (FlagPl) {
						mode++;
						if (mode==5) mode = 0;
						Kcounter=20;
						}
			}


		if (Icounter==10)	//no 2
			{
			Icounter=0;
			if (mode==0)
				{
				ftoa (altitude, str01, 1, 'G');
				strcpypgm2ram(DisplayBuffer,"alt:    ");			
				strcat(DisplayBuffer,str01);
				}

			if (mode==1)
				{
				ftoa (pressure, str01, 1, 'G');
				strcpypgm2ram(DisplayBuffer,"pres:   ");			
				strcat(DisplayBuffer,str01);
				}

			if (mode==2)
				{
				btoa (MemAd, str01);
				strcpypgm2ram(DisplayBuffer,"mem:    ");			
				strcat(DisplayBuffer,str01);
				if (FlagOk)
					{
					Lcounter++;
					if (Lcounter>6)
						{
						FlagMem=~FlagMem;
						Lcounter=0;
						}
					}
				else Lcounter=0;
				}

			if (mode==3)
				{
				ftoa (temper, str01, 1, 'F');
				strcpypgm2ram(DisplayBuffer,"temp:   ");			
				strcat(DisplayBuffer,str01);
				}


			if (mode==4)
				{
				btoa (Jcounter, str01);
				strcpypgm2ram(DisplayBuffer,"OFF? ");			
				strcat(DisplayBuffer,str01);
				if (FlagOk)
					{
					Jcounter++;
					if (Jcounter>6) FlagOff=1;
						
					}
				else Jcounter=0;
				}
			if (FlagMem)
				{
				strcpypgm2ram(str01,"M");			
				strcat(DisplayBuffer,str01);
				}
			putslcd(DisplayBuffer);
			write_nil();
			Ypos=0;
			}//end of no 2
		} //end of 1
}
