#include <p18F2550.h>
#include <usart.h>
#include <stdlib.h> 
#include <delays.h>
#include <float.h>
#include <adc.h>
#include <string.h>
#include <i2c.h>
#include <math.h>
#include "1wire.h"
#include "typedefs.h"


//#include "system\typedefs.h"
//#include "system\usb\usb.h"
//#include "io_cfg.h"             // I/O pin mapping

#define CAL_CONST (-5.0)

#define	ENL LATCbits.LATC7
#define	RSL LATCbits.LATC6

#define Cycles 800
#define Cycles_j 8
#define MEMORY_SIZE 32768

static unsigned char Ypos;
unsigned int n;
unsigned char hadd;
unsigned char ladd;
unsigned char data;
unsigned char length;
unsigned int  pagesize,MemAd;
//unsigned char pstring[64];
unsigned char Icounter,Kcounter,Jcounter,Lcounter,Mcounter;
unsigned char str01[16],DisplayBuffer[17],DataString[5];
unsigned char mode,interval;
char tem;
long  result;
float 		pressure,pressuret,altitude,alt,altitudet,altold1,altold2,altold3,temper,MemPer;
unsigned int res,i,j,alt_int,RPres,RAlt;

//void lowspeed_init(void);
void InterruptHandlerHigh (void);
void measure_alt (void);
void Settings (void);
void measure_pre (void);


#define button_pl PORTBbits.RB4
#define button_mi PORTBbits.RB5
#define button_ok PORTCbits.RC0

typedef unsigned char   byte;           // 8-bit
typedef union _BYTE
{
    byte _byte;
    struct
    {
        unsigned b0:1;
        unsigned b1:1;
        unsigned b2:1;
        unsigned b3:1;
        unsigned b4:1;
        unsigned b5:1;
        unsigned b6:1;
        unsigned b7:1;
    };
} BYTE;

BYTE	flag;
BYTE	flag2;

#define		FlagOk flag.b0
#define		FlagPl flag.b1
#define		FlagMi flag.b2
#define		FlagOff flag.b3
#define		FlagMem flag.b4
#define		FlagFin flag.b5
#define		MenuNormal flag.b6
#define		FlagMark flag.b7
#define		Marker flag2.b0

void lcdt (unsigned char data);
void lcdc (unsigned char data);
void initLCD(void);




void initLCD(void)
{
	Delay1KTCYx(50); // Delay of 15ms		
	RSL=0;
	LATB=LATB|0x0C;
	LATB=LATB&0x0F;
	ENL=1;
	_asm
	nop
	_endasm
	ENL=0;
	Delay1KTCYx(4); // Delay of 15ms		
	ENL=1;
	_asm
	nop
	_endasm
	ENL=0;
	Delay1KTCYx(1); // Delay of 15ms		
	ENL=1;
	_asm
	nop
	_endasm
	ENL=0;
	Delay1KTCYx(1); // Delay of 15ms		
	LATB=LATB&0x03;
	LATB=LATB|0x08;
	ENL=1;
	_asm
	nop
	_endasm
	ENL=0;
	Delay1KTCYx(4); // Delay of 15ms		
	Ulcdc(0x28);		//!!!2lines!!!, 4bit,5*7font
	Ulcdc(0x0C);		//disp on,blink & cursor off
	Ulcdc(0x01);		//erase disp, cursor home
}


void lcdc (unsigned char data)
{
	unsigned char datat;
	datat=data;
	RSL=0;
	ENL=1;
	datat>>=4;
	datat=datat&0x0F;
	datat<<=2;
	LATB=LATB&0x03;
	LATB=(LATB|datat);
	ENL=0;
	RSL=0;
	ENL=1;
	data<<=2;
	LATB=LATB&0x03;
	LATB=(LATB|(data&0x3F));
	ENL=0;
	Delay10TCYx(20);
	Delay10TCYx(20);
}


void lcdt (unsigned char data)
{
	unsigned char datat;
	datat=data;
	RSL=1;
	ENL=1;
	datat>>=4;
	datat=datat&0x0F;
	datat<<=2;
	LATB=LATB&0x03;
	LATB=(LATB|datat);
	ENL=0;
	RSL=1;
	ENL=1;
	data<<=2;
	LATB=LATB&0x03;
	LATB=(LATB|(data&0x3F));
	ENL=0;
	Delay10TCYx(70);
}

void putslcd(char *data)
{
	if ((Ypos<0)|(Ypos>15)) Ypos=0;
	if (Ypos==0) lcdc(0b10000000);
	if ((Ypos>=0)&(Ypos<=7))
		{
		while((*data != '\0')&(Ypos<8))
  			{  
		  	lcdt(*data);
			*data++;
			Ypos++;
		  	}
		}
if (Ypos==8) lcdc(0b11000000);
if ((Ypos>=8)&(Ypos<=15))
		{
		while((*data != '\0')&(Ypos<16))
  			{  
		  	lcdt(*data);
			*data++;
			Ypos++;
		  	}
		}
}


void putrslcd(const rom char *data)
{
//	if (y<20) Ypos=y;
	if ((Ypos<0)|(Ypos>15)) Ypos=0;
	if (Ypos==0) lcdc(0b10000000);
	if ((Ypos>=0)&(Ypos<=7))
		{
		while((*data != '\0')&(Ypos<8))
  			{  
		  	lcdt(*data);
			*data++;
			Ypos++;
		  	}
		}
if (Ypos==8) lcdc(0b11000000);
if ((Ypos>=8)&(Ypos<=15))
		{
		while((*data != '\0')&(Ypos<16))
  			{  
		  	lcdt(*data);
			*data++;
			Ypos++;
		  	}
		}
}

void write_nil(void)
{
unsigned char i;
if (Ypos<15)
	{
	for (i=Ypos;i<16;i++) 
		{
		if ((i<0)|(i>15)) i=0;
		if (i==0) lcdc(0b10000000);
		if ((i>=0)&(i<=7))
			{
			while(i<8)
	  			{  
			  	lcdt(' ');
				i++;
			  	}
			}
		if (i==8) lcdc(0b11000000);
		if ((i>=8)&(i<=15))
			{
			while(i<16)
	  			{  
			  	lcdt(' ');
				i++;
		  		}
			}
		}
	}
}

void writeEE(unsigned char adr,unsigned char dat)
	{
	EECON1bits.EEPGD = 0;  	/* WRITE step #1 */
  	EECON1bits.WREN = 1;   	/* WRITE step #2 */
  	EECON1bits.CFGS = 0;
  	EEADR = adr;            /* WRITE step #3 */
  	EEDATA = dat;    		/* WRITE step #4 */
  	EECON2 = 0x55;         	/* WRITE step #5 */
  	EECON2 = 0xaa;         	/* WRITE step #6 */
  	EECON1bits.WR = 1;     	/* WRITE step #7 */
  	while (!PIR2bits.EEIF); /* WRITE step #8 */
    PIR2bits.EEIF = 0;     	/* WRITE step #9 */
	}

unsigned char readEE (unsigned char adr)
	{
	EECON1bits.EEPGD = 0;  	/* READ step #1 */
  	EECON1bits.CFGS = 0;
  	EEADR = adr;            /* READ step #2 */
	Delay10TCYx(4);			//delay, see Errata
  	EECON1bits.RD = 1;     	/* READ step #3 */
  	return EEDATA;    		/* READ step #4 */
	}


void Settings (void)
{
	strcpypgm2ram(DisplayBuffer,"Settings");			
	putslcd(DisplayBuffer);
	write_nil();
	Ypos=0;
//	Convert_Temperature();
	Delay10KTCYx(100);	
//	PORTAbits.RA2=0;
	temper = Read_Temperature_DS18S20();
	while (!(FlagOk))
			{
			Delay10KTCYx(20);	
			if (FlagMi)	RAlt--;
			if (FlagPl) RAlt++;
			itoa (RAlt, str01);
			strcpypgm2ram(DisplayBuffer,"RAlt:   ");			
			strcat(DisplayBuffer,str01);
			putslcd(DisplayBuffer);
			write_nil();
			Ypos=0;
			}
	measure_pre();
	strcpypgm2ram(DisplayBuffer,"RPre:   ----    ");			
	strcat(DisplayBuffer,str01);
	putslcd(DisplayBuffer);
	write_nil();
	Ypos=0;
	Delay10KTCYx(1000);	
	while (!(FlagOk))
			{
			Delay10KTCYx(20);	
			if (FlagMi)	RPres--;
			if (FlagPl) RPres++;
			itoa (RPres, str01);
			strcpypgm2ram(DisplayBuffer,"RPre:   ");			
			strcat(DisplayBuffer,str01);
			putslcd(DisplayBuffer);
			write_nil();
			Ypos=0;
			}
	strcpypgm2ram(DisplayBuffer,"time:   --      ");			
	strcat(DisplayBuffer,str01);
	putslcd(DisplayBuffer);
	write_nil();
	Ypos=0;
	interval=readEE(5);
	Delay10KTCYx(1000);	
	while (!(FlagOk))
			{
			Delay10KTCYx(20);	
			if (FlagMi)	interval--;
			if (FlagPl) interval++;
			if (interval>50) interval=50;
			if (interval<2) interval=2;
			btoa (interval, str01);
			strcpypgm2ram(DisplayBuffer,"time:   ");			
			strcat(DisplayBuffer,str01);
			putslcd(DisplayBuffer);
			write_nil();
			Ypos=0;
			}
}




void measure_pre (void)
{
		PORTAbits.RA2=1;
		Delay10KTCYx(2);	//warm-up
		result=0;
		for (i=0;i<Cycles;i++)
				{
				ConvertADC(); // Start conversion
				while( BusyADC() ); // Wait for completion
				result = result + ReadADC(); // Read result		
				}
		pressuret = (((result / (1023.0*Cycles))+0.095)* 1111.1111)+CAL_CONST;
		RPres= pressuret/(exp(-((RAlt*9.81)/(286*(273.15+temper)))));
		PORTAbits.RA2=0;
}


void measure_alt (void)
{
		LATAbits.LATA2=1;
		alt=0.0;
		Delay10KTCYx(2);	//warm-up
		for (j=0;j<Cycles_j;j++)
				{
				result=0;
				for (i=0;i<Cycles;i++)
					{
					ConvertADC(); // Start conversion
					while( BusyADC() ); // Wait for completion
					result = result + ReadADC(); // Read result		
					}
				pressuret = (((result / (1023.0*Cycles))+0.095)* 1111.1111)+CAL_CONST;
				alt=alt + (-log(pressuret/RPres))*((286.0*(temper+273.15))/9.81);
				}
		LATAbits.LATA2=0;
		alt=alt/Cycles_j;
//		altitudet=alt;
		altitudet=(alt+altold1+altold2+altold3)/4.0;
		altold3=altold2;
		altold2=altold1;
		altold1=alt;

}



void On(void)
{
	FlagOff=0;
	FlagMem=0;
	DDRB=0;
	TRISCbits.TRISC2=1;
  	DDRCbits.RC0 = 1;
	PORTC=0b00000100;
  	DDRCbits.RC7 = 0;
  	DDRCbits.RC6 = 0;
  	DDRCbits.RC1 = 0;
	LATCbits.LATC1=0;
	Delay10KTCYx(10);
	initLCD();
	PORTAbits.RA3=1;
	Delay10KTCYx(25);
	LATCbits.LATC1=1;
	Delay10KTCYx(30);
}

void Off (void)
{
		if (FlagMem)
			{
			DataString[0]=0xFF;
			DataString[1]=0xFF;
			DataString[2]=0xFF;
			DataString[3]=0xFF;
			ladd=MemAd&0x00FF;
			hadd=MemAd>>8;
			EEAckPolling(0xA0);
			EPageWrite(0xA0,hadd,ladd,DataString,4);
			}
	  	INTCONbits.GIE = 0; 
		strcpypgm2ram(DisplayBuffer,"..OFF...");			
		putslcd(DisplayBuffer);
		Delay10KTCYx(250);
		Delay10KTCYx(250);
		Ypos=0;
		write_nil();
		Delay10KTCYx(10);
		PORTCbits.RC1=0;

}

void lowspeed_init(void)
{
	TRISAbits.TRISA0=1;
	TRISAbits.TRISA1=1;
	TRISAbits.TRISA2=0;
	TRISAbits.TRISA3=1;
	PORTAbits.RA2=1;
	DDRBbits.RB2 = 0;       //Define CS as Output
	DDRBbits.RB1 = 0;       //Define SCK as Output
  	DDRBbits.RB0 = 1;
	DDRBbits.RB7 = 1;
  	DDRBbits.RB6 = 1;
	SSPSTAT = 0xC0;         //SPI Bus mode 0,0
	SSPCON1 = 0x21;         //Enable SSP, Fosc/16

}


void main_lowspeed (void)
{
	MemAd=0;
	mode=0;
	MenuNormal=1;
	Icounter=0;
	Kcounter=0;
	Lcounter=0;
	Jcounter=0;
	FlagFin=0;
	TRISAbits.TRISA0=1;
	INTCON2bits.RBPU=0;
	ADCON0=0x01;
	ADCON1=0x1D;
	ADCON2=0x3C;//3C
	ADCON2bits.ADFM=1;
	OpenI2C(MASTER, SLEW_ON);// Initialize I2C module
	SSPADD = 0x09;
	Convert_Temperature();
	lcdt(' ');
	Ulcdc(0x01);
	strcpypgm2ram(DisplayBuffer,"vyskomer");			
	putslcd(DisplayBuffer);
	write_nil();
	Ypos=0;
	Delay10KTCYx(100);	
	TMR1L=188;	
	TMR1H=60;
	PIE1bits.TMR1IE=1;
	T1CON=0b00000001;
  	INTCONbits.GIE = 1; 
  	INTCONbits.PEIE = 1; 
	interval=readEE(5);
	RAlt=readEE(1)+(256*readEE(2));
	TRISB=0xFF;
	if (button_pl==0)
		{
		TRISB=TRISB&0b11000011;
		MenuNormal=0;
		Settings();
		MenuNormal=1;

		altitudet=RAlt;
		pressuret=RPres;
		writeEE(1,RAlt&0x00FF);
		writeEE(2,RAlt>>8);
		writeEE(3,RPres&0x00FF);
		writeEE(4,RPres>>8);
		writeEE(5,interval);
		}
	else 
		{
		RPres=readEE(3)+(256*readEE(4));
		RAlt=readEE(1)+(256*readEE(2));
		interval=readEE(5);
		}
	TRISB=TRISB&0b11000011;
	altold1=altold2=altold3=alt=altitude=altitudet=RAlt;
	pressure=pressuret=RPres;
	temper=20.0;
	TMR1L=188;	
	TMR1H=60;
	PIE1bits.TMR1IE=1;
	T1CON=0b00000001;
	Icounter=0;
	Kcounter=0;
	Lcounter=0;
	Jcounter=0;
	FlagOff=0;
	FlagMark=0;
	mode=1;





while (1)
		{
		measure_alt();
		Delay10KTCYx(40);	
	  	INTCONbits.GIE = 0; 
  		INTCONbits.GIE = 0; 
		temper = Read_Temperature_DS18S20();
		Convert_Temperature();
		altitude=altitudet;
		pressure=pressuret;
		alt_int=(int)altitude;
	  	INTCONbits.GIE = 1; 
		if (FlagOff==1) Off();
		}//looping forever

}

#pragma code InterruptVectorHigh = 0x08
void
InterruptVectorHigh (void)
{
  _asm
    goto InterruptHandlerHigh //jump to interrupt routine
  _endasm
}

//----------------------------------------------------------------------------
// High priority interrupt routine

#pragma code
#pragma interrupt InterruptHandlerHigh

void InterruptHandlerHigh ()
{
	if (PIR1bits.TMR1IF) //no. 1
		{
		PIR1bits.TMR1IF=0;
		TMR1L=18;	
		TMR1H=62;
		Icounter++;
		Kcounter++;
		TRISB=0xFF;
		if (button_pl==0)
				{
				if (button_pl==0) FlagPl=1;
				}
		else FlagPl=0;
		if (button_mi==0)
				{
				if (button_mi==0) FlagMi=1;
				}
		else FlagMi=0;
		if (button_ok==0)
				{
				if (button_ok==0) FlagOk=1;
				}
		else FlagOk=0;
		TRISB=TRISB&0b11000011;

		if (Kcounter==42)
			{
			Kcounter=40;
			if (FlagPl) {
						mode++;
						if (mode==8) mode = 1;
						Kcounter=20;
						}
			if (FlagMi) {
						mode--;
						if (mode==0) mode = 7;
						Kcounter=20;
						}

			}


		if ((Icounter==10)&(MenuNormal))	//no 2
			{
			Icounter=0;
			if (1)	//mn
			{							//3
			if (mode==1)
				{
				ftoa (altitude, str01, 1, 'G');
				strcpypgm2ram(DisplayBuffer,"alt:    ");			
				strcat(DisplayBuffer,str01);
				}

			if (mode==2)
				{
				ftoa (pressure, str01, 1, 'G');
				strcpypgm2ram(DisplayBuffer,"pres:   ");			
				strcat(DisplayBuffer,str01);
				}

			if (mode==3)
				{
				MemPer=(float)(MemAd*100.0)/MEMORY_SIZE;				
				ftoa (MemPer, str01, 2, 'G');
				if (FlagMem) strcpypgm2ram(DisplayBuffer,"wri:    ");			
				else strcpypgm2ram(DisplayBuffer,"mem:    ");			
				strcat(DisplayBuffer,str01);
				strcpypgm2ram(str01,"%");			
				strcat(DisplayBuffer,str01);

				if (FlagOk)
					{
					Lcounter++;
					if (Lcounter>6)
						{
						if (MemAd<(MEMORY_SIZE-1)) FlagMem=~FlagMem;
						Lcounter=0;
						}
					}
				else Lcounter=0;
				}

			if (mode==4)
				{
				if (!(FlagMem)) strcpypgm2ram(DisplayBuffer,"//marker//");
				else{
					if (FlagMark) strcpypgm2ram(DisplayBuffer,"marking");			
					else strcpypgm2ram(DisplayBuffer,"mark?");			
					if (FlagOk)
						{
						Lcounter++;
						if (Lcounter>6)
							{
							FlagMark=1;
							Lcounter=0;
							}
						}
					else Lcounter=0;
					}
				}


			if (mode==5)
				{
				ftoa (temper, str01, 1, 'F');
				strcpypgm2ram(DisplayBuffer,"temp:   ");			
				strcat(DisplayBuffer,str01);
				}

			if (mode==6)
				{
				itoa (RPres, str01);
				strcpypgm2ram(DisplayBuffer,"Rres:   ");			
				strcat(DisplayBuffer,str01);
				}


			if (mode==7)
				{
				btoa (Jcounter, str01);
				strcpypgm2ram(DisplayBuffer,"OFF? ");			
				strcat(DisplayBuffer,str01);
				if (FlagOk)
					{
					Jcounter++;
					if (Jcounter>6) FlagOff=1;
						
					}
				else Jcounter=0;
				}

			if (FlagMem)
				{
				FlagFin=1;
				Mcounter++;
				if (Mcounter==interval)
					{
					Mcounter=0;
					ladd=MemAd&0x00FF;
					hadd=MemAd>>8;
					DataString[0]=0x00;
					if (FlagMark) DataString[0]=0xEE;
					DataString[1]=alt_int&0x00FF;
					DataString[2]=alt_int>>8;
					DataString[3]=((unsigned char)temper*2);
					EPageWrite(0xA0,hadd,ladd,DataString,4);
					EEAckPolling(0xA0);
					MemAd=MemAd+4;
					FlagMark=0;
					}
				}
			else Mcounter=0;

			if (MemAd>(MEMORY_SIZE-1)) FlagMem=0;

			if ((FlagFin)&(FlagMem==0))
				{
					DataString[0]=0xFF;
					DataString[1]=0xFF;
					DataString[2]=0xFF;
					DataString[3]=0xFF;
					ladd=MemAd&0x00FF;
					hadd=MemAd>>8;
					EEAckPolling(0xA0);
					EPageWrite(0xA0,hadd,ladd,DataString,4);
					FlagFin=0;
				}
			}//end of 3
	
			putslcd(DisplayBuffer);
			write_nil();
			Ypos=0;
			}//end of no 2
		} //end of 1
}
